
;16-bit DOS program
;display keyboard character codes
;by DednDave

;-------------------------------------------------------------------------

        .MODEL  SMALL
        .STACK  512

;-------------------------------------------------------------------------

        .DATA

ExitMsg db 'Press Esc Key to Exit',0Dh,0Ah,24h

;-------------------------------------------------------------------------

        .CODE

_main   PROC

;set the DS register to the data segment

        mov     ax,@DATA
        mov     ds,ax

;display the exit message

        mov     dx,offset ExitMsg
        mov     ah,9
        int     21h

;poll the keyboard

DosKb0: call    KbInp
        jnz     DosKb1

;if no keyboard character, 55 ms delay, then try again

        call    Delay
        jmp     DosKb0

;we have a character
;test for Esc Key - if it is, exit
;if not, display the character and character code
;then go back for another key

DosKb1: push    ax
        int     29h             ;display the character
        mov     al,20h
        int     29h             ;display a space character
        pop     ax
        call    U2Dec           ;display the number in AX
        cmp     al,27           ;was it esc key ?
        jnz     DosKb0          ;no - do another key

;terminate

DosKb2: mov     ax,4C00h
        int     21h

_main   ENDP

;-------------------------------------------------------------------------

KbInp   PROC

;poll the keyboard for a character
;if it is an extended key, read the extended character

;returns with ZF set if there is no key
;returns with ZF clear if there is a key

; regular key: ah = 0, al = key
;extended key: al = 0, ah = extended key

;note: the function keys are extended keys

        mov     dl,0FFh
        mov     ah,6
        int     21h
        mov     ah,0
        jz      KBinp0

        or      al,al
        jnz     KbInp0

        mov     dl,0FFh
        mov     ah,6
        int     21h
        mov     ah,al
        mov     al,0
        xor     dx,dx
        dec     dx            ;clear the ZF

KbInp0: ret

KbInp   ENDP

;-------------------------------------------------------------------------

Delay   PROC

;delay for about 55 ms - that is fast enough for 180 wpm typing

;get the initial timer count

        mov     ah,0
        int     1Ah
        xchg    ax,dx
        add     ax,3

;once ~55 ms has elapsed, exit the routine

Delay0: push    ax
        mov     ah,0
        int     1Ah
        pop     ax
        cmp     ax,dx
        ja      Delay0

        ret

Delay   ENDP

;-------------------------------------------------------------------------

U2Dec   PROC

;display unsigned word from AX in decimal
;the number is terminated with a carriage return/line feed
;all registers are preserved, including flags

        pushf
        push    ax
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    bp
        mov     bx,240Ah             ;line feed and terminator
        push    bx
        mov     bx,0D00h             ;carriage return
        push    bx
        mov     bp,sp
        sub     sp,4
        mov     bx,10

U2Dec0: xor     dx,dx
        div     bx
        or      dl,30h
        mov     [bp],dl
        dec     bp
        or      ax,ax
        jnz     U2Dec0

        inc     bp
        mov     dx,bp
        mov     ah,9
        push    ds
        push    ss
        pop     ds
        int     21h
        pop     ds

        add     sp,8
        pop     bp
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        popf
        ret

U2Dec   ENDP

;-------------------------------------------------------------------------

        END     _main

